﻿Type=Class
Version=3.5
@EndOfDesignText@
'SlideMenu Class module
'
'Author:  Markus Stipp
'Version: 1.0

'Class module
Private Sub Class_Globals
	Type ActionItem (Text As String, Image As Bitmap, Value As Object)
	
	Private mSlidePanel As Panel
	Private mBackPanel As Panel
	
	Private MyPanel As Panel
	
	Private mModule As Object
	Private mEventName As String
	

	Private mInAnimation1 As Animation
	Private mOutAnimation1 As Animation
End Sub

'Initializes the SlideMenu object
' Activity - Pass a reference to the Activity here where the Slidemenu should be added to.
' Module - The calling Module. Pass the "Me" reference here
' EventNAme - EventName for the Click event
' Top - Top position of the Menu.
' Width - Width of the menu
Sub Initialize(Activity As Activity, Module As Object, EventName As String, Top As Int, Width As Int)
	mModule = Module
	mEventName = EventName

	mSlidePanel.Initialize("mSlidePanel")
	MyPanel.Initialize ("MyPanel")
	
	Activity.AddView(mSlidePanel, 0, Top, Width, 100%y - Top)
	
	mBackPanel.Initialize("mBackPanel")
	mBackPanel.Color = Colors.Red 
	mBackPanel.Visible = False
	
	Dim zgoraj As Int
	Dim sirina As Int
	Dim visina As Int
	sirina = mSlidePanel.Width /2
	visina = mSlidePanel.Height * 0.8
	zgoraj = (100%y - visina)/2
	mSlidePanel.AddView(mBackPanel, 0,zgoraj,sirina,visina)
	
	mSlidePanel.Visible = False
	
	MyPanel.Color = Colors.Yellow 
	Log("mBackPanel Width = " & mBackPanel.Width )
	
	
	mInAnimation1.InitializeTranslate("", -sirina, 0, 0, 0)
	mInAnimation1.Duration = 1200
	mOutAnimation1.InitializeTranslate("Out", 0, 0, -sirina, 0)
	mOutAnimation1.Duration = 1200
	
End Sub


'Show the SlideMenu
Public Sub Show
	If isVisible = True Then Return
	
	mBackPanel.BringToFront
	mSlidePanel.BringToFront
	'MyPanel.BringToFront 
	mBackPanel.Left = 0
	mSlidePanel.Left = 0
	mBackPanel.Visible = True
	mSlidePanel.Visible = True
	mInAnimation1.Start(mSlidePanel)
End Sub

'Hide the SlideMenu
Public Sub Hide
	If isVisible = False Then Return
	'mBackPanel.Left = -mBackPanel.Width
    'mSlidePanel.Left = -mSlidePanel.Width
	mOutAnimation1.Start(mSlidePanel)
End Sub

Private Sub Out_AnimationEnd
	mSlidePanel.Visible = False
End Sub

Private Sub mBackPanel_Touch (Action As Int, X As Float, Y As Float)
	If Action = 1 Then
		Hide
	End If
End Sub

'Check if the menu is currently visible
Public Sub isVisible As Boolean
	Return mSlidePanel.Visible
End Sub